#ifndef __CAPTURER_THREAD__
#define __CAPTURER_THREAD__

#define MAX_BYTES_CAPTURE 65535

// flow_state's para saber el estado de las conexiones TCP (Maquina de estados del 3WHS y del 4WHS)
#define EMPTY_TCP           1000
#define TWHS_SYN		    1001
#define TWHS_SYN_ACK	    1002
#define THWS_ACK		    1003
#define DATA			    1004
#define FWHS_FIN			1005
#define FWHS_ACK            1006
#define FWHS_FIN2           1007
#define FWHS_ACK2_CLOSED    1008
// flow_state's para estado de conexiones TCP donde no hemos capturado el inicio del 3WHS de los datos...
#define TCP_DATA			1009
#define TCP_FIN			    1010
#define TCP_ACK             1011
#define TCP_FIN2            1012
#define TCP_ACK2_CLOSED     1013
// flow_state para UDP
#define UDP_DATA 			1014
// flow_state para ICMP
#define ICMP_DATA			1015
// flow_state other
#define UNDEFINED			1016 
// flow_state error
#define FLOW_ERROR          1017

// Macros
#define IP_PAYLOAD(estr_ip) (estr_ip->ip_hl*4)
#define TCP_PAYLOAD(estr_tcp) (estr_tcp->th_off*4)

#define GET_VALUE(variable)  (variable)
#define SET_VALUE(variable, i)  (variable = i)

#define RAISE_INFORMATION(bytes, gigs, quantity, err)	{	bytes = bytes + quantity;						\
															if (bytes >= GIGA) {							\
																gigs++; 									\
																if (gigs >= (unsigned long) GIGA) {			\
																	gigs = 0;								\
																	err++;									\
																}											\
																bytes = bytes >> 30;						\
															}												\
														}

#define DECREASE_INFORMATION(bytes, gigs, quantity)	{	bytes = bytes - quantity;					\
														if ((bytes < GIGA) && (gigs > 0)) {			\
															gigs--; 								\
															bytes = bytes << 30;					\
												   		}											\
												  	}

#define UPDATE_MAX(current_bytes, current_gigs, max_bytes, max_gigs) 						\
					{	if ( ((current_gigs == max_gigs) && (current_bytes > max_bytes)) || \
							 (current_gigs > max_gigs) ) {									\
							 	max_bytes = current_bytes;									\
							 	max_gigs = current_gigs;									\
						}																	\
					}

void *init_capturer (void *arg);
void *processer_thread (void *args);
void free_all_memory(bytes_and_packets *bytes_and_packs_ptr);
int save_to_disk (char *file_name, bytes_and_packets *bytes_and_packs);

#endif /* __CAPTURER_THREAD__ */
