#ifndef __COMMON__
#define __COMMON__

#define TYPE_CAPTURER	0x01
#define TYPE_PROCESSER	0x02

#define CONCATENATE_FREE_BLOCK(first_block, last_block, free_first, free_last, free_counter, blocks, mutex)	\
					{	pthread_mutex_lock(&mutex);															\
						last_block->next = NULL;															\
						if (free_last != NULL) {															\
							free_last->next = first_block;													\
							free_last = last_block;															\
						} else {																			\
							free_first = first_block;														\
							free_last = last_block;															\
						}																					\
						free_counter += blocks;																\
						pthread_mutex_unlock(&mutex);														\
					}

char *remove_blanks (char *word);
char *remove_initial_final_blanks (char *word);
char *give_filename_from_last_slash (char *file_path, char *result);
void replace_string_with(char *line, char *to_substitute_token, char *final_token);
int read_line(int fd, char *line);
unsigned long allocate_memory (bytes_and_packets *iface, unsigned long packets_to_allocate);
long purge_sparse_memory(bytes_and_packets *iface, long packets_to_free);
int create_file_system (char *initial_directory, char *output_file, int type, int create_dirs, int use_time_passed, time_t time_passed, int fuid, int fgid);

#endif /* __COMMON__ */
