#ifndef __CONFIG_FILE__
#define __CONFIG_FILE__

#include <ctype.h>
#include <pwd.h>

#define MAX_STRING_IFACES 100

// Default values
#define IFACES "eth0, eth1, en0, en1, fxp0, rl0, eri0, hme0, ce0, bge0"
#define MAX_PACKETS 250000L
#define MIN_PACKETS MAX_PACKETS/100L
#define MAX_HASH_LISTENER 10000L
#define MAX_HASH_FLOW_ADDER 100L
#define CAPTURE_TIME 15
#define PROCESS_TIME 15
#define UNFINISHED_CONNECTIONS_TIME 120
#define HOME_DIRECTORY "."
#define CAPTURE_DIRECTORY "./captured"
#define PROCESSED_DIRECTORY "./processed"
#define LISTENER_PID "./listener.pid"
#define FLOW_ADDER_PID "./flow_adder.pid"
#define LISTENER_LOG_FILE "./listener.log"
#define FLOW_ADDER_LOG_FILE "./flow_adder.log"
#define DEFAULT_GROUP "root"
#define NICE_LEVEL 20
#define COMPRESS_PATH "gzip --best"
#define UNCOMPRESS_PATH "gunzip -c"
#define GNUPLOT_PATH "gnuplot"
#define KEEP_DAYS 7
#define TOP_N 20
#define LOCAL_NETWORK "192.168."

char *get_interfaces (char *filename);
int get_capture_time (char *filename);
int get_process_time (char *filename);
int get_unfinished_connections_time (char *filename);
unsigned long get_max_block_number (char *filename);
unsigned long get_min_block_number (char *filename);
unsigned long get_hash_size_listener (char *filename);
unsigned long get_hash_size_flow_adder (char *filename);
char *get_home_directory (char *filename);
char *get_captured_directory (char *filename);
char *get_processed_directory (char *filename);
char *get_listener_pid (char *filename);
char *get_flow_adder_pid (char *filename);
char *get_listener_log_file (char *filename);
char *get_flow_adder_log_file (char *filename);
char *get_group (char *filename);
int get_gid_group (char *filename);
int get_nice_level (char *filename);
char *get_compress_path (char *filename);
char *get_uncompress_path (char *filename);
char *get_gnuplot_path (char *filename);
int get_keep_days (char *filename);
int get_top_n (char *filename);
char *get_local_network (char *filename);

#endif /* __CONFIG_FILE__ */
