#ifndef __NORMALIZER__
#define __NORMALIZER__

#define SECONDS_PER_MINUTE 60
#define PROCESS_PARSE_TIME	5
#define PROCESS_PARSE_TIME_SECONDS	(PROCESS_PARSE_TIME*60)

#define DOT_CAPTURED  0x001
#define DOT_PROCESSED 0x002

#define TYPE_DAY 0x0101
#define TYPE_WEEK 0x0102
#define TYPE_MONTH 0x0103
#define TYPE_YEAR 0x0104

#define STATISTICS_FILE_BEGIN 0x0200
#define STATISTICS_FILE_CONNECTIONS 0x0201
#define STATISTICS_FILE_BANDWIDTH 0x0202
#define STATISTICS_FILE_TOTAL_TOP_BYTES_RECEIVED 0x0203
#define STATISTICS_FILE_TOTAL_TOP_BYTES_TCP_RECEIVED 0x0204
#define STATISTICS_FILE_TOTAL_TOP_BYTES_UDP_RECEIVED 0x0205
#define STATISTICS_FILE_TOTAL_TOP_BYTES_ICMP_RECEIVED 0x0206
#define STATISTICS_FILE_TOTAL_TOP_BYTES_OTHERS_RECEIVED 0x0207
#define STATISTICS_FILE_LOCAL_TOP_BYTES_RECEIVED 0x0223
#define STATISTICS_FILE_LOCAL_TOP_BYTES_TCP_RECEIVED 0x0224
#define STATISTICS_FILE_LOCAL_TOP_BYTES_UDP_RECEIVED 0x0225
#define STATISTICS_FILE_LOCAL_TOP_BYTES_ICMP_RECEIVED 0x0226
#define STATISTICS_FILE_LOCAL_TOP_BYTES_OTHERS_RECEIVED 0x0227
#define STATISTICS_FILE_TOTAL_TOP_BYTES_SENT 0x0208
#define STATISTICS_FILE_TOTAL_TOP_BYTES_TCP_SENT 0x0209
#define STATISTICS_FILE_TOTAL_TOP_BYTES_UDP_SENT 0x0210
#define STATISTICS_FILE_TOTAL_TOP_BYTES_ICMP_SENT 0x0211
#define STATISTICS_FILE_TOTAL_TOP_BYTES_OTHERS_SENT 0x0212
#define STATISTICS_FILE_LOCAL_TOP_BYTES_SENT 0x0238
#define STATISTICS_FILE_LOCAL_TOP_BYTES_TCP_SENT 0x0239
#define STATISTICS_FILE_LOCAL_TOP_BYTES_UDP_SENT 0x0240
#define STATISTICS_FILE_LOCAL_TOP_BYTES_ICMP_SENT 0x0241
#define STATISTICS_FILE_LOCAL_TOP_BYTES_OTHERS_SENT 0x0242
#define STATISTICS_FILE_TOTAL_TOP_CONNECTIONS_RECEIVED 0x1203
#define STATISTICS_FILE_TOTAL_TOP_CONNECTIONS_TCP_RECEIVED 0x1204
#define STATISTICS_FILE_TOTAL_TOP_CONNECTIONS_UDP_RECEIVED 0x1205
#define STATISTICS_FILE_TOTAL_TOP_CONNECTIONS_ICMP_RECEIVED 0x1206
#define STATISTICS_FILE_TOTAL_TOP_CONNECTIONS_OTHERS_RECEIVED 0x1207
#define STATISTICS_FILE_LOCAL_TOP_CONNECTIONS_RECEIVED 0x1223
#define STATISTICS_FILE_LOCAL_TOP_CONNECTIONS_TCP_RECEIVED 0x1224
#define STATISTICS_FILE_LOCAL_TOP_CONNECTIONS_UDP_RECEIVED 0x1225
#define STATISTICS_FILE_LOCAL_TOP_CONNECTIONS_ICMP_RECEIVED 0x1226
#define STATISTICS_FILE_LOCAL_TOP_CONNECTIONS_OTHERS_RECEIVED 0x1227
#define STATISTICS_FILE_TOTAL_TOP_CONNECTIONS_SENT 0x1208
#define STATISTICS_FILE_TOTAL_TOP_CONNECTIONS_TCP_SENT 0x1209
#define STATISTICS_FILE_TOTAL_TOP_CONNECTIONS_UDP_SENT 0x1210
#define STATISTICS_FILE_TOTAL_TOP_CONNECTIONS_ICMP_SENT 0x1211
#define STATISTICS_FILE_TOTAL_TOP_CONNECTIONS_OTHERS_SENT 0x1212
#define STATISTICS_FILE_LOCAL_TOP_CONNECTIONS_SENT 0x1238
#define STATISTICS_FILE_LOCAL_TOP_CONNECTIONS_TCP_SENT 0x1239
#define STATISTICS_FILE_LOCAL_TOP_CONNECTIONS_UDP_SENT 0x1240
#define STATISTICS_FILE_LOCAL_TOP_CONNECTIONS_ICMP_SENT 0x1241
#define STATISTICS_FILE_LOCAL_TOP_CONNECTIONS_OTHERS_SENT 0x1242
#define STATISTICS_FILE_TOTAL_TOP_TCP_PORTS 0x3213
#define STATISTICS_FILE_TOTAL_TOP_UDP_PORTS 0x3214
#define STATISTICS_FILE_LOCAL_TOP_TCP_PORTS 0x3223
#define STATISTICS_FILE_LOCAL_TOP_UDP_PORTS 0x3224

#define RAISE_INFORMATION(bytes, gigs, new_bytes, new_gigs)			\
	{																\
		bytes = bytes + new_bytes;									\
		if (bytes >= GIGA_MODIF) {									\
			gigs += new_gigs + (bytes / GIGA_MODIF);				\
			bytes = bytes >> 30;									\
		}															\
		else {														\
			gigs += new_gigs;										\
		}															\
	}

#define PRECALCULATED_BYTES(aux_element_bytes, max, mode, top_n, actual_top, aux_line, fd)				\
	{																									\
		aux_element_bytes = get_top_bytes (mode, max);													\
		while ((aux_element_bytes != NULL) && (actual_top < top_n)) {									\
			if (mode == MODE_LONGLONG)																	\
				sprintf(aux_line, "IP: %s    Bytes: %llu\n", inet_ntoa(aux_element_bytes->ip_address),	\
						aux_element_bytes->ll_bytes);													\
			else if (mode == MODE_DOUBLE)																\
				sprintf(aux_line, "IP: %s    Bytes: %.0f\n", inet_ntoa(aux_element_bytes->ip_address),	\
						aux_element_bytes->d_bytes);													\
			write(fd, aux_line, strlen(aux_line));														\
			deallocate_element_bytes (aux_element_bytes);												\
			aux_element_bytes = get_top_bytes (mode, max);												\
			actual_top++;																				\
		}																								\
		if (aux_element_bytes != NULL) deallocate_element_bytes (aux_element_bytes);					\
		write(fd, "\n", strlen("\n"));																	\
	}

#define PRECALCULATED_BYTES_VIS(aux_element_bytes, max, mode, top_n, actual_top, aux_line, fd, of, fd2)	\
	{																									\
		aux_element_bytes = get_top_bytes (mode, max);													\
		fd2 = open (of, O_WRONLY|O_CREAT|O_APPEND);														\
		while ((aux_element_bytes != NULL) && (actual_top < top_n)) {									\
			if (mode == MODE_LONGLONG)																	\
				sprintf(aux_line, "IP: %s    Bytes: %llu\n", inet_ntoa(aux_element_bytes->ip_address),	\
						aux_element_bytes->ll_bytes);													\
			else if (mode == MODE_DOUBLE) {																\
				sprintf(aux_line, "IP: %s    Bytes: %.0f\n", inet_ntoa(aux_element_bytes->ip_address),	\
						aux_element_bytes->d_bytes);													\
				sprintf(of, "%s\t%.0f\n", inet_ntoa(aux_element_bytes->ip_address),						\
						aux_element_bytes->d_bytes);													\
				write (fd2, of, strlen(of));															\
			}																							\
			write(fd, aux_line, strlen(aux_line));														\
			deallocate_element_bytes (aux_element_bytes);												\
			aux_element_bytes = get_top_bytes (mode, max);												\
			actual_top++;																				\
		}																								\
		close(fd2);																						\
		if (aux_element_bytes != NULL) deallocate_element_bytes (aux_element_bytes);					\
		write(fd, "\n", strlen("\n"));																	\
	}

#define PRECALCULATED_ACCESSED(aux_element_accessed, max, mode, top_n, actual_top, aux_line, fd)			\
	{																										\
		aux_element_accessed = get_top_accessed (mode, max);												\
		while ((aux_element_accessed != NULL) && (actual_top < top_n)) {									\
			if (mode == MODE_LONGLONG)																		\
				sprintf(aux_line, "IP: %s    Times: %llu\n", inet_ntoa(aux_element_accessed->ip_address),	\
						aux_element_accessed->ll_accessed);													\
			else if (mode == MODE_DOUBLE)																	\
				sprintf(aux_line, "IP: %s    Times: %.0f\n", inet_ntoa(aux_element_accessed->ip_address),	\
						aux_element_accessed->d_accessed);													\
			write(fd, aux_line, strlen(aux_line));															\
			deallocate_element_accessed (aux_element_accessed);												\
			aux_element_accessed = get_top_accessed (mode, max);											\
			actual_top++;																					\
		}																									\
		if (aux_element_accessed != NULL) deallocate_element_accessed (aux_element_accessed);				\
		write(fd, "\n", strlen("\n"));																		\
	}

#define PRECALCULATED_ACCESSED_VIS(aux_element_accessed, max, mode, top_n, actual_top, aux_line, fd, of, fd2)	\
	{																											\
		aux_element_accessed = get_top_accessed (mode, max);													\
		fd2 = open (of, O_WRONLY|O_CREAT|O_APPEND);																\
		while ((aux_element_accessed != NULL) && (actual_top < top_n)) {										\
			if (mode == MODE_LONGLONG)																			\
				sprintf(aux_line, "IP: %s    Times: %llu\n", inet_ntoa(aux_element_accessed->ip_address),		\
						aux_element_accessed->ll_accessed);														\
			else if (mode == MODE_DOUBLE) {																		\
				sprintf(aux_line, "IP: %s    Times: %.0f\n", inet_ntoa(aux_element_accessed->ip_address),		\
						aux_element_accessed->d_accessed);														\
				sprintf(of, "%s\t%.0f\n", inet_ntoa(aux_element_accessed->ip_address),							\
						aux_element_accessed->d_accessed);														\
				write (fd2, of, strlen(of));																	\
			}																									\
			write(fd, aux_line, strlen(aux_line));																\
			deallocate_element_accessed (aux_element_accessed);													\
			aux_element_accessed = get_top_accessed (mode, max);												\
			actual_top++;																						\
		}																										\
		close(fd2);																								\
		if (aux_element_accessed != NULL) deallocate_element_accessed (aux_element_accessed);					\
		write(fd, "\n", strlen("\n"));																			\
	}

#define PRECALCULATED_PORTS(aux_element_ports, max, mode, top_n, actual_top, aux_line, fd)				\
	{																									\
		aux_element_ports = get_top_ports (mode, max);													\
		while ((aux_element_ports != NULL) && (actual_top < top_n)) {									\
			if (mode == MODE_LONGLONG)																	\
				sprintf(aux_line, "Port: %u    Times: %llu\n", aux_element_ports->port_number,			\
						aux_element_ports->ll_times);													\
			else if (mode == MODE_DOUBLE)																\
				sprintf(aux_line, "Port: %u    Times: %.0f\n", aux_element_ports->port_number,			\
						aux_element_ports->d_times);													\
			write(fd, aux_line, strlen(aux_line));														\
			deallocate_element_ports (aux_element_ports);												\
			aux_element_ports = get_top_ports (mode, max);												\
			actual_top++;																				\
		}																								\
		if (aux_element_ports != NULL) deallocate_element_ports (aux_element_ports);					\
		write(fd, "\n", strlen("\n"));																	\
	}

#define PRECALCULATED_PORTS_VIS(aux_element_ports, max, mode, top_n, actual_top, aux_line, fd, of, fd2)	\
	{																									\
		aux_element_ports = get_top_ports (mode, max);													\
		fd2 = open (of, O_WRONLY|O_CREAT|O_APPEND);														\
		while ((aux_element_ports != NULL) && (actual_top < top_n)) {									\
			if (mode == MODE_LONGLONG)																	\
				sprintf(aux_line, "Port: %u    Times: %llu\n", aux_element_ports->port_number,			\
						aux_element_ports->ll_times);													\
			else if (mode == MODE_DOUBLE) {																\
				sprintf(aux_line, "Port: %u    Times: %.0f\n", aux_element_ports->port_number,			\
						aux_element_ports->d_times);													\
				sprintf(of, "%u\t%.0f\n", aux_element_ports->port_number,								\
						aux_element_ports->d_times);													\
				write (fd2, of, strlen(of));															\
			}																							\
			write(fd, aux_line, strlen(aux_line));														\
			deallocate_element_ports (aux_element_ports);												\
			aux_element_ports = get_top_ports (mode, max);												\
			actual_top++;																				\
		}																								\
		close(fd2);																						\
		if (aux_element_ports != NULL) deallocate_element_ports (aux_element_ports);					\
		write(fd, "\n", strlen("\n"));																	\
	}

#define READ_STATISTICS_DATA(tmp_line, rline, double_point_char, aux_line, value_d, value_ll, mode)	\
	{																								\
		tmp_line = strtok(rline, double_point_char);												\
		tmp_line = strtok(NULL, double_point_char);													\
		strcpy(aux_line, tmp_line);																	\
		remove_blanks(aux_line);																	\
		if (mode == MODE_DOUBLE) {																	\
			value_d += atof(aux_line);																\
		}																							\
		else if (mode == MODE_LONGLONG) {															\
			value_ll += atoll(aux_line);															\
		}																							\
	}

#define READ_STATISTICS_IP_DATA(tmp_line, rline, double_point_char, space_char, aux_line, aux_line2, ip_address, very_long)	\
	{																														\
			tmp_line = strtok(rline, double_point_char);																	\
			tmp_line = strtok(NULL, double_point_char);																		\
			strcpy(aux_line, tmp_line);																						\
			tmp_line = strtok(NULL, double_point_char);																		\
			strcpy(aux_line2, tmp_line);																					\
			very_long = atoll(aux_line2);																					\
			tmp_line = strtok(aux_line, space_char);																		\
			if (inet_aton(tmp_line, &ip_address) == 0) {																	\
				sprintf(buffer_debug, "Error converting IP address %s in total_top_bytes_received", tmp_line);				\
				save_debug(bytes_and_packs->interface, buffer_debug);														\
				return -1;																									\
			}																												\
	}

#define READ_STATISTICS_PORTS_DATA(tmp_line, rline, double_point_char, space_char, aux_line, aux_line2, port, very_long)	\
	{																														\
			tmp_line = strtok(rline, double_point_char);																	\
			tmp_line = strtok(NULL, double_point_char);																		\
			strcpy(aux_line, tmp_line);																						\
			tmp_line = strtok(NULL, double_point_char);																		\
			strcpy(aux_line2, tmp_line);																					\
			very_long = atol(aux_line2);																					\
			tmp_line = strtok(aux_line, space_char);																		\
			port = (unsigned int) atoi (tmp_line);																			\
	}

typedef struct FLOW_ADDER_STRUCT {
	char filename[MAX_LINE];
	long begin;
	long end;
	struct FLOW_ADDER_STRUCT *next;
} flow_adder_struct;

typedef struct DISK_PATH_STRUCT {
	int dir_year;
	int dir_month;
	int dir_week;
	int dir_day;
} disk_path_struct;

typedef struct INTERFACE_STR {
	char name[MAX_LENGTH_IFACE];
} interface_str;

void initialize_bytes_and_packets (unsigned int max_intrfacs, interface_str *interface);
int is_a_directory (char *filename);
#ifdef _VIEWER
int read_and_process_statistics_file (char *filename, bytes_and_packets *bytes_and_packs, int mode, char *output_file, char *time_to_write);
int save_statistics (char *file_name, bytes_and_packets *bytes_and_packs, int mode, char *output_file);
#else
int read_and_process_statistics_file (char *filename, bytes_and_packets *bytes_and_packs, int mode);
int save_statistics (char *file_name, bytes_and_packets *bytes_and_packs, int mode);
#endif
void free_all_memory(int position);
int flow_adder_process (char *captured_directory, char *processed_directory, char *interface, int position, long *first_time, long *last_time);

#endif /* __NORMALIZER__ */
