#ifndef __VIEWER__
#define __VIEWER__

#define DAY_SECONDS (24*60*60)
#define WEEK_SECONDS (7*DAY_SECONDS)
#define MONTH_SECONDS (30*DAY_SECONDS)

#define LEVEL_SUBDAY	0x701
#define LEVEL_DAY		0x702
#define LEVEL_WEEK		0x703
#define LEVEL_MONTH		0x704

#define FILE_HEAD_INITIALISE(fd, file_gid, aux_line2, output_file, interface, filename, first_line, second_line)	\
	{																												\
		sprintf(aux_line2, "%s.%s.%s", output_file, interface, filename);											\
		fd = open(aux_line2, O_WRONLY|O_CREAT|O_TRUNC);																\
		if (fd >= 0) {																								\
						sprintf(aux_line2, first_line);																\
						write(fd, aux_line2, strlen(aux_line2));													\
						sprintf(aux_line2, second_line);															\
						write(fd, aux_line2, strlen(aux_line2));													\
		}																											\
		close(fd);																									\
		sprintf(aux_line2, "%s.%s.%s", output_file, interface, filename);											\
		chown(aux_line2, (uid_t) -1, file_gid);																		\
		chmod(aux_line2, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP);															\
	}

#define GNUPLOT_STATISTICS_ACCUMULATIVE(fd_graph, tmp_graphic_file, filename, interface, graphic_string, ini_day, \
		ini_month, ini_year, ini_hour, ini_min, fin_day, fin_month, fin_year, fin_hour, fin_min, aux_line, aux_line2, \
		gnuplot_bin_path, str_min, str_may)	\
	{																															\
		sprintf(tmp_graphic_file, "/tmp/.viewer.%s.%d", interface, (int) getpid());											\
		fd_graph = open (tmp_graphic_file, O_WRONLY|O_CREAT|O_TRUNC);															\
		if (fd_graph >= 0) {																									\
			sprintf(graphic_string, "set terminal png nocrop enhanced size 1024,768\n");										\
			write(fd_graph, graphic_string, strlen(graphic_string));															\
			sprintf(graphic_string, "set xdata time\n");																		\
			write(fd_graph, graphic_string, strlen(graphic_string));															\
			sprintf(graphic_string, "set timefmt \"%%d/%%m/%%Y-%%H:%%M\"\n");													\
			write(fd_graph, graphic_string, strlen(graphic_string));															\
			sprintf(graphic_string, "set format y \"%%0.f\"\n");																\
			write(fd_graph, graphic_string, strlen(graphic_string));															\
			sprintf(graphic_string, "set xrange [\"%02d/%02d/%04d-%02d:%02d\":\"%02d/%02d/%04d-%02d:%02d\"]\n", 				\
					ini_day, ini_month, ini_year, ini_hour, ini_min, fin_day, fin_month, fin_year, fin_hour, fin_min);			\
			write(fd_graph, graphic_string, strlen(graphic_string));															\
			sprintf(graphic_string, "set format x \"   %%H:%%M\"\n");															\
			write(fd_graph, graphic_string, strlen(graphic_string));															\
			sprintf(graphic_string, "set title \"Total %s from %02d/%02d/%04d %02d:%02d until %02d/%02d/%04d %02d:%02d\\n \
( Total and distributed by protocol )\"\n", str_min, ini_day, ini_month, ini_year, ini_hour,									\
					ini_min, fin_day, fin_month, fin_year, fin_hour, fin_min);													\
			write(fd_graph, graphic_string, strlen(graphic_string));															\
			sprintf(graphic_string, "set xlabel \"Time value\"\n");																\
			write(fd_graph, graphic_string, strlen(graphic_string));															\
			sprintf(graphic_string, "set ylabel \"%s established\"\n", str_may);												\
			write(fd_graph, graphic_string, strlen(graphic_string));															\
			sprintf(graphic_string, "set xtics rotate by 90\n");																\
			write(fd_graph, graphic_string, strlen(graphic_string));															\
			sprintf(graphic_string, "set output \"%s.png\"\n", filename);														\
			write(fd_graph, graphic_string, strlen(graphic_string));															\
			sprintf(graphic_string, "plot \"%s.gnuplot\" using 1:2 title \'Total %s\' with lines, \\\n", filename, str_min);	\
			write(fd_graph, graphic_string, strlen(graphic_string));															\
			sprintf(graphic_string, "\"%s.gnuplot\" using 1:3 title \'TCP %s\' with lines, \\\n", filename, str_min);			\
			write(fd_graph, graphic_string, strlen(graphic_string));															\
			sprintf(graphic_string, "\"%s.gnuplot\" using 1:4 title \'UDP %s\' with lines, \\\n", filename, str_min);			\
			write(fd_graph, graphic_string, strlen(graphic_string));															\
			sprintf(graphic_string, "\"%s.gnuplot\" using 1:5 title \'ICMP %s\' with lines, \\\n", filename, str_min);			\
			write(fd_graph, graphic_string, strlen(graphic_string));															\
			sprintf(graphic_string, "\"%s.gnuplot\" using 1:6 title \'OTHERS %s\' with lines\n", filename, str_min);			\
			write(fd_graph, graphic_string, strlen(graphic_string));															\
			close(fd_graph);																									\
			chown(tmp_graphic_file, (uid_t) -1, file_gid);																		\
			chmod(tmp_graphic_file, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP);															\
			sprintf(aux_line, "%s %s >/dev/null 2>/dev/null", gnuplot_bin_path, tmp_graphic_file);														\
			system(aux_line);																									\
			sprintf(aux_line2, "%s.png", filename);																				\
			chown(aux_line2, (uid_t) -1, file_gid);																				\
			chmod(aux_line2, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP);																	\
			unlink(tmp_graphic_file);																							\
			sprintf(aux_line,"%s.gnuplot", filename);																			\
			unlink(aux_line);																									\
		}																														\
	}

#define GNUPLOT_STATISTICS_TOP(fd_graph, tmp_graphic_file, num_top, filename, interface, graphic_string, ini_day, \
		ini_month, ini_year, ini_hour, ini_min, fin_day, fin_month, fin_year, fin_hour, fin_min, aux_line, aux_line2, \
		gnuplot_bin_path, total_may, bytes_may, bytes_min, received_min, first_colum_ip_may) \
	{																																\
		sprintf(tmp_graphic_file, "%s.gnuplot", filename);																			\
		fd_graph = open (tmp_graphic_file, O_RDONLY);																				\
		if (fd_graph >= 0)																											\
		{																															\
			close(fd_graph);																										\
			sprintf(tmp_graphic_file, "/tmp/.viewer.%s.%d", interface, (int) getpid());											\
			fd_graph = open (tmp_graphic_file, O_WRONLY|O_CREAT|O_TRUNC);															\
			if (fd_graph >= 0) {																									\
				sprintf(graphic_string, "set terminal png nocrop enhanced size 1024,768\n");										\
				write(fd_graph, graphic_string, strlen(graphic_string));															\
				sprintf(graphic_string, "set style data histograms\n");																\
				write(fd_graph, graphic_string, strlen(graphic_string));															\
				sprintf(graphic_string, "set boxwidth\n");																			\
				write(fd_graph, graphic_string, strlen(graphic_string));															\
				sprintf(graphic_string, "set style fill solid 1.0 border -1\n");													\
				write(fd_graph, graphic_string, strlen(graphic_string));															\
				sprintf(graphic_string, "set format y \"%%0.f\"\n");																\
				write(fd_graph, graphic_string, strlen(graphic_string));															\
				sprintf(graphic_string, "set title \"%s TOP %d %s %s\\n (from %02d/%02d/%04d %02d:%02d until %02d/%02d/%04d %02d:%02d)\"\n",\
						total_may, num_top, bytes_min, received_min, ini_day, ini_month, ini_year, ini_hour, ini_min,				\
						fin_day, fin_month, fin_year, fin_hour, fin_min);															\
				write(fd_graph, graphic_string, strlen(graphic_string));															\
				sprintf(graphic_string, "set xlabel \"%s\"\n", first_colum_ip_may);													\
				write(fd_graph, graphic_string, strlen(graphic_string));															\
				sprintf(graphic_string, "set ylabel \"%s %s\"\n", bytes_may, received_min);											\
				write(fd_graph, graphic_string, strlen(graphic_string));															\
				sprintf(graphic_string, "set xtics rotate by 90\n");																\
				write(fd_graph, graphic_string, strlen(graphic_string));															\
				sprintf(graphic_string, "set output \"%s.png\"\n", filename);														\
				write(fd_graph, graphic_string, strlen(graphic_string));															\
				sprintf(graphic_string, "plot \"%s.gnuplot\" using 2:xticlabels(1) title \'%s %s\'\n", filename, bytes_may, 		\
						received_min);																								\
				write(fd_graph, graphic_string, strlen(graphic_string));															\
				close(fd_graph);																									\
				chown(tmp_graphic_file, (uid_t) -1, file_gid);																		\
				chmod(tmp_graphic_file, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP);															\
				sprintf(aux_line, "%s %s >/dev/null 2>/dev/null", gnuplot_bin_path, tmp_graphic_file);								\
				system(aux_line);																									\
				sprintf(aux_line2, "%s.png", filename);																				\
				chown(aux_line2, (uid_t) -1, file_gid);																				\
				chmod(aux_line2, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP);																	\
				unlink(tmp_graphic_file);																							\
				sprintf(aux_line,"%s.gnuplot", filename);																			\
				unlink(aux_line);																									\
			}																														\
		}																															\
	}


typedef struct VIEWER_FILES_STRUCT {
	char filename[MAX_LINE];
	char time[MAX_LINE];
	struct VIEWER_FILES_STRUCT *next;
} viewer_files_struct;

int generate_statistics_viewer (char *output_file, char *interface, struct tm initial_time_struct, struct tm final_time_struct);

#endif /* __VIEWER__ */
