#include <defines.h>
#include <common.h>
#include <config_file.h>
#include <grp.h>

extern char buffer_debug[MAX_BUFFER];

int read_config_file = 0;

char interfaces_config[MAX_STRING_IFACES];
int capture_time_config;
int process_time_config;
int unfinished_connections_config;
unsigned long max_block_number_config;
unsigned long min_block_number_config;
unsigned long hash_size_listener_config;
unsigned long hash_size_flow_adder_config;
char home_directory_config[MAX_LINE];
char captured_directory_config[MAX_LINE];
char processed_directory_config[MAX_LINE];
char listener_pid_config[MAX_LINE];
char flow_adder_pid_config[MAX_LINE];
char listener_log_file_config[MAX_LINE];
char flow_adder_log_file_config[MAX_LINE];
char group_config[MAX_LINE];
int nice_level_config;
char compress_path_config[MAX_LINE];
char uncompress_path_config[MAX_LINE];
char gnuplot_path_config[MAX_LINE];
int keep_days_config;
int top_n_config;
char local_network_config[MAX_LINE];

char *convert_to_lower (char *source, char *destination)
{
	int i;
	int tamanyo = strlen(source);

	for (i = 0; i < tamanyo; i++) {
		destination[i] = (char) tolower(source[i]);
	}
	destination[strlen(source)] = '\0';

	return destination;
}

int read_file (char *filename)
{
	int fd, result, line_number;
	char *result_line = NULL, *result_line2 = NULL, *first_occurrence = NULL;
	char characters[2]="=";
	char line[MAX_LINE], tmp_path[MAX_LINE];
	char original_line[MAX_LINE];
	char lower_token[MAX_LINE];

	// Default initialization
	strcpy(interfaces_config, IFACES);
	capture_time_config = CAPTURE_TIME;
	process_time_config = PROCESS_TIME;
	unfinished_connections_config = UNFINISHED_CONNECTIONS_TIME;
	max_block_number_config = MAX_PACKETS;
	min_block_number_config = MIN_PACKETS;
	hash_size_listener_config = MAX_HASH_LISTENER;
	hash_size_flow_adder_config = MAX_HASH_FLOW_ADDER;
	strcpy(home_directory_config, HOME_DIRECTORY);
	strcpy(captured_directory_config, CAPTURE_DIRECTORY);
	strcpy(processed_directory_config, PROCESSED_DIRECTORY);
	strcpy(listener_pid_config, LISTENER_PID);
	strcpy(flow_adder_pid_config, FLOW_ADDER_PID);
	strcpy(listener_log_file_config, LISTENER_LOG_FILE);
	strcpy(flow_adder_log_file_config, FLOW_ADDER_LOG_FILE);
	strcpy(group_config, DEFAULT_GROUP);
	nice_level_config = NICE_LEVEL;
	strcpy(compress_path_config, COMPRESS_PATH);
	strcpy(uncompress_path_config, UNCOMPRESS_PATH);
	strcpy(gnuplot_path_config, GNUPLOT_PATH);
	keep_days_config = KEEP_DAYS;
	top_n_config = TOP_N;
	strcpy(local_network_config, LOCAL_NETWORK);

	fd = open(filename, O_RDONLY);
	if (fd < 0) {
		sprintf(buffer_debug, "Error opening config file");
		save_debug("father", buffer_debug);
	}
	result = read_line(fd, line);
	strcpy(original_line, line);
	if (strlen(line)>0) remove_blanks(line);
	line_number = 1;

	while ((result >= 0) || (strlen(line) > 0)) {
		if (strlen(line) > 0) {
			result_line = strtok(line, characters);
			convert_to_lower (result_line, lower_token);
			if (strcmp(lower_token, "interfaces") == 0) {
				result_line = strtok(NULL, characters);
				if ((result_line != NULL) && (strlen(result_line) > 0)) strcpy(interfaces_config, result_line);
				else {
					printf("Error in line %d: %s\n", line_number, line);
					exit (1);
				}
			}
			else if (strcmp(lower_token, "capture_time") == 0) {
				result_line = strtok(NULL, characters);
				if ((result_line != NULL) && (strlen(result_line) > 0)) {
					capture_time_config = atoi(result_line);
					if (capture_time_config < 1) {
						printf("Error in line %d: Value %d forbidden\n", line_number, capture_time_config);
						exit(1);
					}
				}
				else {
					printf("Error in line %d: %s\n", line_number, line);
					exit (1);
				}
			}
			else if (strcmp(lower_token, "process_time") == 0) {
				result_line = strtok(NULL, characters);
				if ((result_line != NULL) && (strlen(result_line) > 0)) {
					process_time_config = atoi(result_line);
					if (process_time_config < 1) {
						printf("Error in line %d: Value %d forbidden\n", line_number, process_time_config);
						exit(1);
					}
				}
				else {
					printf("Error in line %d: %s\n", line_number, line);
					exit (1);
				}
			}
			else if (strcmp(lower_token, "timeout_unfinished_connections") == 0) {
				result_line = strtok(NULL, characters);
				if ((result_line != NULL) && (strlen(result_line) > 0)) {
					unfinished_connections_config = atoi(result_line);
					if (unfinished_connections_config < 1) {
						printf("Error in line %d: Value %d forbidden\n", line_number, unfinished_connections_config);
						exit(1);
					}
				}
				else {
					printf("Error in line %d: %s\n", line_number, line);
					exit (1);
				}
			}
			else if (strcmp(lower_token, "max_block_number") == 0) {
				result_line = strtok(NULL, characters);
				if ((result_line != NULL) && (strlen(result_line) > 0)) max_block_number_config = atoi(result_line);
				else {
					printf("Error in line %d: %s\n", line_number, line);
					exit (1);
				}
			}
			else if (strcmp(lower_token, "min_block_number") == 0) {
				result_line = strtok(NULL, characters);
				if ((result_line != NULL) && (strlen(result_line) > 0)) min_block_number_config = atoi(result_line);
				else {
					printf("Error in line %d: %s\n", line_number, line);
					exit (1);
				}
			}
			else if (strcmp(lower_token, "hash_size_listener") == 0) {
				result_line = strtok(NULL, characters);
				if ((result_line != NULL) && (strlen(result_line) > 0)) hash_size_listener_config = atoi(result_line);
				else {
					printf("Error in line %d: %s\n", line_number, line);
					exit (1);
				}
			}
			else if (strcmp(lower_token, "hash_size_flow_adder") == 0) {
				result_line = strtok(NULL, characters);
				if ((result_line != NULL) && (strlen(result_line) > 0)) hash_size_flow_adder_config = atoi(result_line);
				else {
					printf("Error in line %d: %s\n", line_number, line);
					exit (1);
				}
			}
			else if (strcmp(lower_token, "home_directory") == 0) {
				result_line2 = strtok(original_line, characters);
				// Y ahora nos saltamos la primera parte
				result_line2 = strtok(NULL, characters);
				if (result_line2 != NULL) {
					strcpy(tmp_path, result_line2);
					remove_initial_final_blanks (tmp_path);
					if (strlen(result_line) > 0) strcpy(home_directory_config, tmp_path);
					else {
						printf("Error in line %d: %s\n", line_number, line);
						exit (1);
					}
				}
				else {
					printf("Error in line %d: %s\n", line_number, line);
				}
			}
			else if (strcmp(lower_token, "captured_directory") == 0) {
				result_line2 = strtok(original_line, characters);
				// Y ahora nos saltamos la primera parte
				result_line2 = strtok(NULL, characters);
				if (result_line2 != NULL) {
					strcpy(tmp_path, result_line2);
					remove_initial_final_blanks (tmp_path);
					if (strlen(result_line) > 0) strcpy(captured_directory_config, tmp_path);
					else {
						printf("Error in line %d: %s\n", line_number, line);
						exit (1);
					}
				}
				else {
					printf("Error in line %d: %s\n", line_number, line);
				}
			}
			else if (strcmp(lower_token, "processed_directory") == 0) {
				result_line2 = strtok(original_line, characters);
				// Y ahora nos saltamos la primera parte
				result_line2 = strtok(NULL, characters);
				if (result_line2 != NULL) {
					strcpy(tmp_path, result_line2);
					remove_initial_final_blanks (tmp_path);
					if (strlen(result_line) > 0) strcpy(processed_directory_config, tmp_path);
					else {
						printf("Error in line %d: %s\n", line_number, line);
						exit (1);
					}
				}
				else {
					printf("Error in line %d: %s\n", line_number, line);
				}
			}
			else if (strcmp(lower_token, "listener_pid") == 0) {
				result_line2 = strtok(original_line, characters);
				// Y ahora nos saltamos la primera parte
				result_line2 = strtok(NULL, characters);
				if (result_line2 != NULL) {
					strcpy(tmp_path, result_line2);
					remove_initial_final_blanks (tmp_path);
					if (strlen(result_line) > 0) strcpy(listener_pid_config, tmp_path);
					else {
						printf("Error in line %d: %s\n", line_number, line);
						exit (1);
					}
				}
				else {
					printf("Error in line %d: %s\n", line_number, line);
				}
			}
			else if (strcmp(lower_token, "flow_adder_pid") == 0) {
				result_line2 = strtok(original_line, characters);
				// Y ahora nos saltamos la primera parte
				result_line2 = strtok(NULL, characters);
				if (result_line2 != NULL) {
					strcpy(tmp_path, result_line2);
					remove_initial_final_blanks (tmp_path);
					if (strlen(result_line) > 0) strcpy(flow_adder_pid_config, tmp_path);
					else {
						printf("Error in line %d: %s\n", line_number, line);
						exit (1);
					}
				}
				else {
					printf("Error in line %d: %s\n", line_number, line);
				}
			}
			else if (strcmp(lower_token, "listener_logfile") == 0) {
				result_line2 = strtok(original_line, characters);
				// Y ahora nos saltamos la primera parte
				result_line2 = strtok(NULL, characters);
				if (result_line2 != NULL) {
					strcpy(tmp_path, result_line2);
					remove_initial_final_blanks (tmp_path);
					if (strlen(result_line) > 0) strcpy(listener_log_file_config, tmp_path);
					else {
						printf("Error in line %d: %s\n", line_number, line);
						exit (1);
					}
				}
				else {
					printf("Error in line %d: %s\n", line_number, line);
				}
			}
			else if (strcmp(lower_token, "flow_adder_logfile") == 0) {
				result_line2 = strtok(original_line, characters);
				// Y ahora nos saltamos la primera parte
				result_line2 = strtok(NULL, characters);
				if (result_line2 != NULL) {
					strcpy(tmp_path, result_line2);
					remove_initial_final_blanks (tmp_path);
					if (strlen(result_line) > 0) strcpy(flow_adder_log_file_config, tmp_path);
					else {
						printf("Error in line %d: %s\n", line_number, line);
						exit (1);
					}
				}
				else {
					printf("Error in line %d: %s\n", line_number, line);
				}
			}
			else if (strcmp(lower_token, "group") == 0) {
				result_line2 = strtok(original_line, characters);
				// Y ahora nos saltamos la primera parte
				result_line2 = strtok(NULL, characters);
				if (result_line2 != NULL) {
					strcpy(tmp_path, result_line2);
					remove_initial_final_blanks (tmp_path);
					if (strlen(result_line) > 0) strcpy(group_config, tmp_path);
					else {
						printf("Error in line %d: %s\n", line_number, line);
						exit (1);
					}
				}
				else {
					printf("Error in line %d: %s\n", line_number, line);
				}
			}
			else if (strcmp(lower_token, "nice_level") == 0) {
				result_line = strtok(NULL, characters);
				if ((result_line != NULL) && (strlen(result_line) > 0)) nice_level_config = atoi(result_line);
				else {
					printf("Error in line %d: %s\n", line_number, line);
					exit (1);
				}
			}
			else if (strcmp(lower_token, "compress_bin_path") == 0) {
				result_line2 = strtok(original_line, characters);
				// Y ahora nos saltamos la primera parte
				result_line2 = strtok(NULL, characters);
				if (result_line2 != NULL) {
					strcpy(tmp_path, result_line2);
					remove_initial_final_blanks (tmp_path);
					if (strlen(result_line) > 0) strcpy(compress_path_config, tmp_path);
					else {
						printf("Error in line %d: %s\n", line_number, line);
						exit (1);
					}
				}
				else {
					printf("Error in line %d: %s\n", line_number, line);
				}
			}
			else if (strcmp(lower_token, "uncompress_bin_path") == 0) {
				result_line2 = strtok(original_line, characters);
				// Y ahora nos saltamos la primera parte
				result_line2 = strtok(NULL, characters);
				if (result_line2 != NULL) {
					strcpy(tmp_path, result_line2);
					remove_initial_final_blanks (tmp_path);
					if (strlen(result_line) > 0) strcpy(uncompress_path_config, tmp_path);
					else {
						printf("Error in line %d: %s\n", line_number, line);
						exit (1);
					}
				}
				else {
					printf("Error in line %d: %s\n", line_number, line);
				}
			}
			else if (strcmp(lower_token, "gnuplot_bin_path") == 0) {
				result_line2 = strtok(original_line, characters);
				// Y ahora nos saltamos la primera parte
				result_line2 = strtok(NULL, characters);
				if (result_line2 != NULL) {
					strcpy(tmp_path, result_line2);
					remove_initial_final_blanks (tmp_path);
					if (strlen(result_line) > 0) strcpy(gnuplot_path_config, tmp_path);
					else {
						printf("Error in line %d: %s\n", line_number, line);
						exit (1);
					}
				}
				else {
					printf("Error in line %d: %s\n", line_number, line);
				}
			}
			else if (strcmp(lower_token, "keep_old_data_captured_days") == 0) {
				result_line = strtok(NULL, characters);
				if ((result_line != NULL) && (strlen(result_line) > 0)) keep_days_config = atoi(result_line);
				else {
					printf("Error in line %d: %s\n", line_number, line);
					exit (1);
				}
			}
			else if (strcmp(lower_token, "top_n") == 0) {
				result_line = strtok(NULL, characters);
				if ((result_line != NULL) && (strlen(result_line) > 0)) top_n_config = atoi(result_line);
				else {
					printf("Error in line %d: %s\n", line_number, line);
					exit (1);
				}
			}
			else if (strcmp(lower_token, "local_network") == 0) {
				result_line2 = strtok(original_line, characters);
				// Y ahora nos saltamos la primera parte
				result_line2 = strtok(NULL, characters);
				if (result_line2 != NULL) {
					strcpy(tmp_path, result_line2);
					remove_initial_final_blanks (tmp_path);
					if (strlen(result_line) > 0) strcpy(local_network_config, tmp_path);
					else {
						printf("Error in line %d: %s\n", line_number, line);
						exit (1);
					}
				}
				else {
					printf("Error in line %d: %s\n", line_number, line);
				}
			}
			else {
				printf("Error in line %d: Unknown parameter (%s)\n", line_number, lower_token);
				exit (1);
			}
		}
		result = read_line(fd, line);
		strcpy(original_line, line);
		if (strlen(line)>0) {
			remove_blanks(line);
		}
		line_number++;
	}
	// And now, replace home_directory key...
	if ((first_occurrence = strstr(captured_directory_config, "home_directory/")) != NULL) {
		strcpy(tmp_path, first_occurrence+strlen("home_directory/"));
		sprintf(captured_directory_config, "%s/%s", home_directory_config, tmp_path);
	}
	if ((first_occurrence = strstr(processed_directory_config, "home_directory/")) != NULL) {
		strcpy(tmp_path, first_occurrence+strlen("home_directory/"));
		sprintf(processed_directory_config, "%s/%s", home_directory_config, tmp_path);
	}
	if ((first_occurrence = strstr(listener_pid_config, "home_directory/")) != NULL) {
		strcpy(tmp_path, first_occurrence+strlen("home_directory/"));
		sprintf(listener_pid_config, "%s/%s", home_directory_config, tmp_path);
	}
	if ((first_occurrence = strstr(flow_adder_pid_config, "home_directory/")) != NULL) {
		strcpy(tmp_path, first_occurrence+strlen("home_directory/"));
		sprintf(flow_adder_pid_config, "%s/%s", home_directory_config, tmp_path);
	}
	if ((first_occurrence = strstr(listener_log_file_config, "home_directory/")) != NULL) {
		strcpy(tmp_path, first_occurrence+strlen("home_directory/"));
		sprintf(listener_log_file_config, "%s/%s", home_directory_config, tmp_path);
	}
	if ((first_occurrence = strstr(flow_adder_log_file_config, "home_directory/")) != NULL) {
		strcpy(tmp_path, first_occurrence+strlen("home_directory/"));
		sprintf(flow_adder_log_file_config, "%s/%s", home_directory_config, tmp_path);
	}

	read_config_file = 1;
	return 0;
}

char *get_interfaces (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return &interfaces_config[0];
}

int get_capture_time (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return capture_time_config;
}

int get_process_time (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return process_time_config;
}

int get_unfinished_connections_time (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return unfinished_connections_config;
}

unsigned long get_max_block_number (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return max_block_number_config;
}

unsigned long get_min_block_number (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return min_block_number_config;
}

unsigned long get_hash_size_listener (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return hash_size_listener_config;
}

unsigned long get_hash_size_flow_adder (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return hash_size_flow_adder_config;
}

char *get_home_directory (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return &home_directory_config[0];
}

char *get_captured_directory (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return &captured_directory_config[0];
}

char *get_processed_directory (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return &processed_directory_config[0];
}

char *get_listener_pid (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return &listener_pid_config[0];
}

char *get_flow_adder_pid (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return &flow_adder_pid_config[0];
}

char *get_listener_log_file (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return &listener_log_file_config[0];
}

char *get_flow_adder_log_file (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return &flow_adder_log_file_config[0];
}

char *get_group (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return &group_config[0];
}

int get_gid_group (char *filename)
{
	struct group *group_pointer;
	int gid_file;

	if (read_config_file == 0) read_file (filename);
	group_pointer = getgrnam(group_config);
	if (group_pointer == NULL) return -1;
	gid_file = (int) group_pointer->gr_gid;
	return gid_file;
}

int get_nice_level (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return nice_level_config;
}

char *get_compress_path (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return &compress_path_config[0];
}

char *get_uncompress_path (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return &uncompress_path_config[0];
}

char *get_gnuplot_path (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return &gnuplot_path_config[0];
}

int get_keep_days (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return keep_days_config;
}

int get_top_n (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return top_n_config;
}

char *get_local_network (char *filename)
{
	if (read_config_file == 0) read_file (filename);
	return &local_network_config[0];
}
